<?php
/*
Plugin Name: WordPlurk improve
Plugin URI: http://www.renn999.twbbs.org/wordpress/archives/577
Description: Generates Plurk Updates when a new Post is Published, Useing Official Plurk api, and Setting improve. Orginal Home page <a href="http://blog.bluefur.com/wordplurk">http://blog.bluefur.com/wordplurk</a>
Author: <a href="http://blog.bluefur.com/">Gary Jones</a>, <a href="http://mattsblog.ca/">Matt Freedman</a>, and <a href="http://www.renn999.twbbs.org">Renn999</a>.
Version: 1.1
Text Domain: wordplurk-improve
*/

if(function_exists('load_plugin_textdomain')){
	$plugin_dir = basename(dirname(__FILE__));
	load_plugin_textdomain( 'wordplurk-improve', 'wp-content/plugins/' . $plugin_dir );
}

add_action('transition_post_status', 'wordplurk_post_now_published', 10, 3);

function plurk_update_status($login_data, $new_status)
{
	
	$curl = curl_init();

	curl_setopt($curl, CURLOPT_RETURNTRANSFER , 1);
	curl_setopt($curl, CURLOPT_COOKIEJAR, 'cookie.txt');
	curl_setopt($curl, CURLOPT_COOKIEFILE, 'cookie.txt');
    curl_setopt($curl, CURLOPT_URL, 'http://www.plurk.com/API/Users/login');
    curl_setopt($curl, CURLOPT_POST , true );
	curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($login_data));
	curl_exec($curl);

	curl_setopt($curl, CURLOPT_URL, 'http://www.plurk.com/API/Timeline/plurkAdd');
	curl_setopt($curl, CURLOPT_POST , true );
	curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($new_status));
	curl_exec($curl);
	curl_close($curl);
	unlink('cookie.txt');

}

function wordplurk_post_now_published($new_status, $old_status, $post)
{

    $post_id = $post->ID;

	if ($new_status == 'publish' && $old_status != 'publish') {
		$has_been_plurked = get_post_meta($post_id, 'has_been_plurked', true);
		if (!($has_been_plurked == 'yes')) {
			query_posts('p=' . $post_id);
			if (have_posts()) {
				the_post();
				$short_urlapi='http://tinyurl.com/api-create.php?url=';
				if (get_option('wordplurk_shorturl_en','1')==1)
					$post_url = file_get_contents($short_urlapi . get_permalink());
				else
					$post_url = get_permalink();
				$title = get_the_title();
				if (strlen($title) > 110) {
					$title = substr_replace($title, '...', 107);
				}
				$plurk_template = get_option('wordplurk_template', 0);
				$i = str_replace(array('%%url%%', '%%title%%'), array($post_url, $title), $plurk_template);
			
				$plurk_username = get_option('wordplurk_username', 0);
				$plurk_password = get_option('wordplurk_password', 0);
			    $plurk_apikey = get_option('wordplurk_apikey', 0);
			    $plurk_qualifier = get_option('wordplurk_qualifier', 0);
			    $plurk_language_set = get_option('wordplurk_language_set', 0);
				$login_data=array(
					'api_key' => "$plurk_apikey", 
					'username' => "$plurk_username",
					'password' => "$plurk_password"
				);

				$status_data=array(
					'api_key' => "$plurk_apikey", 
					'qualifier' => "$plurk_qualifier",
					'content' => "$i",
					'no_comments' => '0',
					'lang' => "$plurk_language_set"
				);
				
				plurk_update_status($login_data, $status_data);
	
				add_post_meta($post_id, 'has_been_plurked', 'yes');
			}
		}
	}
}

function wordplurk_options_subpanel()
{
	?>
	<div class="wrap">
	<h2>WordPlurk <?php _e('Settings', 'wordplurk-improve'); ?></h2>
	<p><?php _e('Please enter your Plurk username and password below. All fields are required.', 'wordplurk-improve'); ?></p>
	<form method="post" action="options.php">
	<?php wp_nonce_field('update-options'); ?>
	<table class="form-table">
	<tr valign="top">
	<th scope="row"><label for="wordplurk_username">Plurk <?php _e('Username', 'wordplurk-improve'); ?></label></th>
	<td><input type="text" name="wordplurk_username" value="<?php echo get_option('wordplurk_username'); ?>">
	<br />
	<?php _e('Enter the username of the Plurk account you want to post updates to.', 'wordplurk-improve');?></td>
	</tr>
	<tr valign="top">
	<th scope="row"><label for="wordplurk_password">Plurk <?php _e('Password', 'wordplurk-improve'); ?></label></th>
	<td><input type="password" name="wordplurk_password" value="<?php echo get_option('wordplurk_password'); ?>">
	<br />
	<?php _e('Enter the password of the Plurk account entered above.', 'wordplurk-improve');?></td>
	</tr>
	<tr valign="top">
	<th scope="row"><label for="wordplurk_apikey">Plurk <?php _e('ApiKey', 'wordplurk-improve'); ?></label></th>
	<td><input type="text" name="wordplurk_apikey" value="<?php echo get_option('wordplurk_apikey'); ?>">
	<br />
	<?php _e('Enter the Api Key of the Plurk account entered above.', 'wordplurk-improve');?></td>
	</tr>
	<tr valign="top">
	<th scope="row"><label for="wordplurk_template"><?php _e('Wordplurk Template', 'wordplurk-improve'); ?></label></th>
	<td><input type="text" name="wordplurk_template" value="<?php echo get_option('wordplurk_template','%%url%% - %%title%%'); ?>">
	<br />
	<?php _e('What template do you want to show on Plurk.', 'wordplurk-improve');?></td>
	</tr>
	<tr valign="top">
	<th scope="row"><label for="wordplurk_qualifier">Plurk <?php _e('Qualifier', 'wordplurk-improve'); ?></label></th>
	<td><select type="text" name="wordplurk_qualifier">
<?php
$plurk_qual=array(
	'loves' => sprintf(__('loves', 'wordplurk-improve')), 
	'likes' => sprintf(__('likes', 'wordplurk-improve')), 
	'shares' => sprintf(__('shares', 'wordplurk-improve')), 
	'gives' => sprintf(__('gives', 'wordplurk-improve')), 
	'hates' => sprintf(__('hates', 'wordplurk-improve')), 
	'wants' => sprintf(__('wants', 'wordplurk-improve')), 
	'has' => sprintf(__('has', 'wordplurk-improve')), 
	'will' => sprintf(__('will', 'wordplurk-improve')), 
	'asks' => sprintf(__('asks', 'wordplurk-improve')), 
	'wishes' => sprintf(__('wishes', 'wordplurk-improve')), 
	'was' => sprintf(__('was', 'wordplurk-improve')), 
	'feels' => sprintf(__('feels', 'wordplurk-improve')), 
	'thinks' => sprintf(__('thinks', 'wordplurk-improve')), 
	'says' => sprintf(__('says', 'wordplurk-improve')), 
	'is' => sprintf(__('is', 'wordplurk-improve')), 
	':' => sprintf(__(':', 'wordplurk-improve')), 
	'freestyle' => sprintf(__('freestyle', 'wordplurk-improve')), 
	'hopes' => sprintf(__('hopes', 'wordplurk-improve')), 
	'needs' => sprintf(__('needs', 'wordplurk-improve')), 
	'wonders' => sprintf(__('wonders', 'wordplurk-improve'))
);
foreach($plurk_qual as $key => $val){
	echo "\t\t<option value=\"$key\"";
	echo (get_option('wordplurk_qualifier','shares')==$key)?' selected="selected"':'';
	echo ">".$val."</option>\n";
}
unset($plurk_qual);
?>
	</select>
	<br />
	<?php _e('Select the Qualifier of the Plurk account entered above.', 'wordplurk-improve');?></td>
	</tr>
	<tr valign="top">
	<th scope="row"><label for="wordplurk_language_set">Plurk <?php _e('language set', 'wordplurk-improve'); ?></label></th>
	<td><select type="text" name="wordplurk_language_set">
<?php
$plurk_lang=array(
	'en' => 'English',
	'pt_BR' => 'Português',
	'cn' => '中文 (中国)',
	'ca' => 'Català',
	'el' => 'Ελληνικά',
	'dk' => 'Dansk',
	'de' => 'Deutsch',
	'es' => 'Español',
	'sv' => 'Svenska',
	'nb' => 'Norsk bokmål',
	'hi' => 'Hindi',
	'ro' => 'Română',
	'hr' => 'Hrvatski',
	'fr' => 'Français',
	'ru' => 'Pусский',
	'it' => 'Italiano ',
	'ja' => '日本語',
	'he' => 'עברית',
	'hu' => 'Magyar',
	'ne' => 'Nederlands',
	'th' => 'ไทย',
	'ta_fp' => 'Filipino',
	'in' => 'Bahasa Indonesia',
	'pl' => 'Polski',
	'ar' => 'العربية',
	'fi' => 'Finnish',
	'tr_ch' => '中文 (繁體中文)',
	'tr' => 'Türkçe',
	'ga' => 'Gaeilge',
	'sk' => 'Slovenský',
	'uk' => 'українська',
	'fa' => 'فارسی'
);
foreach($plurk_lang as $key => $val){
	echo "\t\t<option value=\"$key\"";
	echo (get_option('wordplurk_language_set','en')==$key)?' selected="selected"':'';
	echo ">".$val."</option>\n";
}
unset($plurk_lang);
?>
	</select>
	<br />
	<?php _e('Select the language set of the Plurk account entered above.', 'wordplurk-improve');?></td>
	</tr>
	<tr valign="top">
	<th scope="row"><label for="wordplurk_shorturl_en"><?php _e('TinyUrl short url', 'wordplurk-improve'); ?></label></th>
	<td><input type="checkbox" name="wordplurk_shorturl_en" value="1" <?php checked(true, get_option('wordplurk_shorturl_en','1'));?>>
	<br />
	<?php _e('Using the TinyUrl to short post url.', 'wordplurk-improve');?></td>
	</tr>
    </table>
	<input type="hidden" name="action" value="update" />
	<input type="hidden" name="page_options" value="wordplurk_username, wordplurk_password, wordplurk_apikey,wordplurk_qualifier,wordplurk_language_set,wordplurk_template,wordplurk_shorturl_en" />
	<p class="submit"><input type="submit" name="submit" value="<?php _e('Save Changes', 'wordplurk-improve') ?>" /></p>
	</form>
	</div>
	<?php 
}

function wordplurk_add_plugin_option()
{
	if (function_exists('add_options_page')) 
	{
		add_options_page('WordPlurk improve', 'WordPlurk improve', 10, 'wordplurk-improve', 'wordplurk_options_subpanel');
    }	
}

add_action('admin_menu', 'wordplurk_add_plugin_option');

function wordplurk_notice()
{
	if (!get_option('wordplurk_username') || !get_option('wordplurk_password') || !get_option('wordplurk_apikey') || !get_option('wordplurk_qualifier') || !get_option('wordplurk_language_set') || !get_option('wordplurk_template'))
	{
		echo '<div class="updated fade" style="padding: 5px;">' . sprintf(__('Please enter your Plurk username and password on the <a href="%1$s" title="WordPlurk Settings">WordPlurk Settings page</a>.', 'wordplurk-improve'), "options-general.php?page=wordplurk-improve") . '</div>';
	}
}

add_action('admin_notices', 'wordplurk_notice');

?>
